<template>
    <div class="wrap">
        <div class="opera-warp">
            <Breadcrumb>
                <BreadcrumbItem >
                    <Select 
                        v-model="model1"
                        @on-change="changeS">
                        <Option v-for="item in frequencys" :value="item.value" :key="item.value">{{ item.label }}</Option>
                    </Select>
                </BreadcrumbItem>
                <BreadcrumbItem>
                    <!-- 坐席王小花 -->
                    <Select v-model="model2">
                        <Option v-for="item in frequencys2" :value="item.value" :key="item.value">{{ item.label }}</Option>
                    </Select>
                </BreadcrumbItem>
                <BreadcrumbItem>
                    <!-- 客户李先生 -->
                    <Select v-model="model3">
                        <Option v-for="item in frequencys3" :value="item.value" :key="item.value">{{ item.label }}</Option>
                    </Select>
                </BreadcrumbItem>
                <BreadcrumbItem>
                    <Select v-model="model4">
                        <Option v-for="item in frequencys4" :value="item.value" :key="item.value">{{ item.label }}</Option>
                    </Select>
                </BreadcrumbItem>
            </Breadcrumb>
            <div class="opera-left">
                <div class="controls-other">
                    <i-switch v-model="switch1" @on-change="change" />
                    <Input search enter-button placeholder="请输入关键字" />
                </div>
                <!-- 播放按钮 -->
                <div class="flex controls-wrap">
                    <Icon type="md-play" @click="play" :size="20"/>
                    <Icon type="md-pause" @click="pause" :size="20"/>
                    <Icon type="md-power"  @click="stop" :size="20"/>
                    <!-- 音量 -->
                    <div class="flex volume-wrap">
                        <Icon type="md-volume-up" :size="20"/>
                        <van-slider v-model="volume"></van-slider>
                    </div>
                    <Icon type="md-open" :size="20"/>
                    <span>语速：</span>
                    <div class="flex volume-wrap">
                        <Slider v-model="audioRate" :min="0.5" :max="2" :step="0.25"></Slider>
                    </div>
                </div>
            </div>
        </div> 
        <!-- 语音波形图 -->
        <div class="waveform-wrap">
            <div id="waveform" ref="waveform"></div>
            <!-- 时间轴 -->
            <div id="wave-timeline" ref="wave-timeline"></div>
        </div>
        <div class="voice-content">
            <div class="client-wrap">
                <ul>
                    <li v-for="(item,index) in voiceContent.client" :key="index">
                        <Button :type="item.type" size="small" @click="toTime(item.timess)" ghost>{{item.content}}</Button>
                    </li>
                </ul>
            </div>
        </div>
        <div class="content-wrap">
            <!-- 歌词 -->
            <div class="flex lrc-wrap" @touchstart="pause">
                <van-picker 
                    ref="lrcpicker"
                    :item-height="itemHeight" 
                    @change="lrcpickerchange" 
                    :columns="columns">
                </van-picker>
            </div>
            <div class="content-right">
                <ul>
                    <li class="li-f">
                        <h3>历史沟通画像</h3>
                        <p>阅读当前通话预计需要33~ 85秒</p>
                        <div class="call">
                            <div class="call-l">
                                <img src="../../assets/client.png" alt="">
                                <p>当前坐席：王妮</p>
                                <p>名单信息：OB_A-，可释放</p>
                                <p>通话语速：4.7 字/秒</p>
                                <p>发话时长：234.3 秒</p>
                            </div>
                            <div class="call-r">
                                <img src="../../assets/客户.png" alt="">
                                <p>蔡先生：当前客户</p>
                                <p>第4次|共6次拨打：沟通信息</p>
                                <div>
                                    ：客户标签
                                    <ul>
                                        <li v-for="(ite,inde) in figures" :key="inde" class="li-t">
                                            <Button :type="ite.type" size="small">{{ite.label}}</Button>
                                        </li>
                                    </ul>
                                </div>
                            </div>
                            
                        </div>
                    </li>
                    <li class="li-f">
                        <h3>关键信息识别</h3>
                        <ul>
                            <li v-for="(item,index) in keyInfos" :key="index" class="li-s li-s-key">
                                <h4>{{item.keyInfo}}<span style="margin-left:10px;">（{{item.times}}）</span>
                                    <img :src="item.src" alt="" v-for="(ite,inde) in item.times" :key="inde">
                                </h4>
                            </li>
                        </ul>
                    </li>
                    <li class="li-f li-f-content">
                        <h3>通话内容点评
                            <Icon type="md-mic" class="record-btn" @click="record" />
                            <Icon type="md-text" class="record-btn" @click="selectReviews" />
                        </h3>
                        <ul>
                            <li v-for="(item,index) in reviews" :key="index" class="li-s">
                                <Button size="small">{{item.label}}</Button>
                            </li>
                            <li class="li-s">
                                <Button size="small" @click="addReviews">+新增</Button>
                            </li>
                        </ul>
                        <Input v-model="opinion" type="textarea" :rows="4" placeholder="填写问题详情及改进意见" />
                    </li>
                </ul>
            </div>
        </div>  
        <Modal
            v-model="reviewsModal"
            title="新增点评"
            @on-ok="ok"
            @on-cancel="cancel">
            <Input v-model="reviewsVal" placeholder="请输入点评内容" style="width: 300px" />
        </Modal>
        <Modal
            v-model="recordModal"
            title="录音点评">
            <img src="../../assets/timg.gif" alt="">
            <div id="recordWaveSurfer" ref="recordWaveSurfer"></div>
            <div slot="footer" style="text-align:center;">
                <Button size="small" @click="recordPlay">开始</Button>
                <Button size="small" @click="recordStop">结束</Button>
            </div>
        </Modal>  
        <Modal
            v-model="moda"
            :title="title"
            @on-ok="ok"
            @on-cancel="cancel">
            <p v-for="(item,index) in checkeds" :key="index">{{item}}</p>
            <Input v-model="value2" maxlength="100" show-word-limit type="textarea" placeholder="请输入点评内容"/>
        </Modal>
        <Modal
            v-model="tagModal"
            title="修改标签"
            @on-cancel="cancel">
            <div style="line-height: 48px;">
                <span style="margin-right:10px;">{{tag}}</span>
                <Button style="margin-right:10px;" @click="edit" type="info" size="small" icon="ios-create" shape="circle">编辑</Button>
                <Button style="margin-right:10px;" @click="dele" type="error" size="small" icon="md-close-circle" shape="circle">删除</Button>
            </div>
            <Input v-model="tagVal" maxlength="100" placeholder="请输入修改原因"/>
        </Modal>
    </div>
</template>

<script>
    import WaveSurfer from 'wavesurfer.js'
    import Timeline from 'wavesurfer.js/dist/plugin/wavesurfer.timeline.js'
    import MicrophonePlugin from 'wavesurfer.js/dist/plugin/wavesurfer.microphone.min.js';
    import { Picker,Icon,Slider} from 'vant';
    import lrc from './newData';
    let playTimeoutTag = 0;
    let timer=null;
    export default {
        name: "Detail",
        data() {
            return {
                checkeds:[],
                title:null,
                itemHeight:32,
                value1:null,
                value2:null,
                moda:false,
                volume: 100,
                audioRate:1,
                model1:1,
                model2:3,
                model3:4,
                model4:4,
                progress: 0,
                progressCurrent: 0,
                progressLength: 0,
                columns: [],
                columnsTime:[
                    '0.40',
                    '3.28',
                    '0.93',
                    '3.48',
                    '0.37',
                    '8.83',
                    '1.22',
                    '0.37',
                    '2.91',
                    '11.03',
                    '3.75',
                    '3.29',
                    '2.29',
                    '2.00',
                    '0.20',
                    '31.81',
                    '4.98',
                    '5.64',
                    '12.22',
                    '43.46',
                    '0.59',
                    '7.43',
                    '0.45',
                    '0.29',
                    '2.75',
                    '13.51',
                    '0.46',
                    '27.09',
                    '0.46',
                    '19.02',
                    '1.24',
                    '1.11',
                    '3.66',
                    '26.28',
                    '0.80',
                    '2.01',
                    '0.54',
                    '16.84',
                    '3.38',
                    '2.29',
                    '6.64',
                    '4.41',
                    '2.79',
                    '7.66',
                    '3.67',
                    '11.59',
                    '1.40',
                    '0.79',
                    '1.59',
                    '5.68',
                    '2.49',
                    '9.42',
                    '10.70',
                    '7.30',
                    '1.41',
                    '0.94',
                    '4.47',
                    '1.20',
                    '0.61',
                    '3.95',
                    '3.03',
                    '2.42',
                    '7.51',
                    '14.07',
                    '1.82',
                    '1.04',
                    '4.75',
                    '2.47',
                    '4.89',
                    '4.23',
                    '10.64',
                    '2.96',
                    '5.14',
                    '0.66',
                    '2.33',
                    '0.79',
                    '2.20',
                    '2.87',
                    '3.87',
                    '7.27',
                    '7.07',
                    '7.67',
                    '13.03',
                    '4.91',
                    '10.09',
                    '3.39',
                    '10.60',
                    '7.82',
                    '6.02',
                    '2.16',
                    '3.42',
                    '5.97',
                    '2.76',
                    '0.73',
                    '0.29',
                    '3.87',
                    '3.66',
                    '5.91',
                    '2.85',
                    '0.26',
                ],
                wavesurfer: null,
                audio:null,
                switch1: false,
                role:null,
                roles:[
                    {
                        value:'all',
                        label:'全部'
                    },
                    {
                        value:'agent',
                        label:'坐席'
                    },
                    {
                        value:'client',
                        label:'客户'
                    },
                ],
                figures:[
                    {
                        label:'价格敏感',
                        type:'primary',
                    },
                    {
                        label:'犹豫不决',
                        type:'warning'
                    },
                    {
                                label:'网络达人',
                                type:'error'
                    },
                    {
                        label:'关注理赔效率',
                        type:'info'
                    }
                ],
                frequencys:[
                    {
                        value:1,
                        label: '王大锤团队'
                    },
                    {
                        value:2,
                        label: '张丽团队'
                    },
                    {
                        value:3,
                        label: '李琳琳团队'
                    },
                ],
                frequencys2:[
                    {
                        value:1,
                        label: '坐席张小虎'
                    },
                    {
                        value:2,
                        label: '坐席王佳'
                    },
                    {
                        value:3,
                        label: '坐席王妮'
                    },
                    {
                        value:4,
                        label: '坐席惠佳'
                    }
                ],
                frequencys3:[
                    {
                        value:1,
                        label: '客户李先生'
                    },
                    {
                        value:2,
                        label: '客户王先生'
                    },
                    {
                        value:3,
                        label: '客户张先生'
                    },
                    {
                        value:4,
                        label: '客户蔡先生'
                    }
                ],
                frequencys4:[
                    {
                        value:1,
                        label: '第1次拨打'
                    },
                    {
                        value:2,
                        label: '第2次拨打'
                    },
                    {
                        value:3,
                        label: '第3次拨打'
                    },
                    {
                        value:4,
                        label: '第4次拨打'
                    },
                    {
                        value:5,
                        label: '第5次拨打'
                    },
                    {
                        value:6,
                        label: '第6次拨打'
                    }
                ],
                communication:[
                    {
                        frequency:1,
                        figures:[
                            {
                                label:'不方便电话',
                                type:'primary',
                            }
                        ]
                    },
                    {
                        frequency:2,
                        figures:[
                            {
                                label:'价格敏感',
                                type:'primary'
                            },
                            {
                                label:'犹豫不决',
                                type:'warning'
                            },
                            {
                                label:'关注理赔效率',
                                type:'error'
                            }
                        ]
                    },
                    {
                        frequency:3,
                        figures:[
                            {
                                label:'怕麻烦',
                                type:'error'
                            },
                            {
                                label:'嫌贵',
                                type:'warning'
                            },
                        ]
                    },
                ],
                keyInfos:[
                    {
                        keyInfo:'非车推荐',
                        times:2,
                        src:require('../../assets/健康 (1).png')
                    },
                    {
                        keyInfo:'阳光服务',
                        times:1,
                        src:require('../../assets/serve.png')
                    }
                ],
                reviews:[
                    {
                        label:'要介绍服务'
                    },
                    {
                        label:'注意保足保全'
                    }
                ],
                opinion:'向客户介绍E赔、一键赔服务；强调更换玻璃是福耀的',
                voiceContent:{
                    client:[
                        {
                            content:'开场白',
                            type:'info',
                            time:'00:01.16',
                            timess:1
                        },
                        {
                            content:'产品报价',
                            type:'error',
                            time:'00:35.28',
                            timess:35
                        },
                        {
                            content:'产品报价',
                            type:'error',
                            time:'00:55.66',
                            timess:55
                        },
                        {
                            content:'实问题；价格异议',
                            type:'error',
                            time:'03:02.99',
                            timess:182,
                        },
                        {
                            content:'异议处理；服务介绍',
                            type:'warning',
                            time:'03:14.54',
                            timess:194
                        },
                        {
                            content:'客户预约',
                            type:'info',
                            time:'05:04.62',
                            timess:304
                        }
                    ],
                    agent:[
                        {
                            content:'开场白',
                            type:'info',
                        },
                        {
                            content:'报价',
                            type:'warning',
                        },
                        {
                            content:'异议处理-未到期',
                            type:'error',
                        },
                        {
                            content:'促成',
                            type:'success',
                        }
                    ]
                },
                warns:[
                    '阳光',
                ],
                keyword:[
                    '试算',
                    '座位险',
                    '道路救援'
                ],
                reviewsModal:false,
                reviewsVal:null,
                recordModal:false,
                recordVal:null,
                recordWaveSurfer:null,
                tagModal:false,
                tag:null,
                tagIndex:null,
                tagVal:null,
                divNodeis:-1,
                currentLen:0,
                dLen:0,
                last:-1,
                cover:null,
                cover1:null,
                cover2:null,
                cover4:null,
                lrcText:[],
                index:0,
                delay:null,
                itemIndex:null,
            }
        },
        components:{
            [Picker.name]: Picker,
            [Icon.name]: Icon,
            [Slider.name]: Slider,
        },
        computed: {
            progressCurrentText() {
                return `${String(this.progressCurrent/60>>0).padStart(2,'0')}:${String(this.progressCurrent%60>>0).padStart(2,'0')}`
            },
            progressLengthText() {
                return `${String(this.progressLength/60>>0).padStart(2,'0')}:${String(this.progressLength%60>>0).padStart(2,'0')}`
            },
        },
        watch: {
            volume() {
                this.wavesurfer.setVolume(this.volume / 100);
            },
            audioRate(){
                this.audio.playbackRate=this.audioRate;
            },
        },
        mounted() {
            this.$nextTick(() => {
                this.wavesurfer = WaveSurfer.create({
                    container: this.$refs.waveform,
                    waveColor: '#409EFF',
                    progressColor: 'blue',
                    backend: 'MediaElement',
                    mediaControls: false,
                    height:50,
                    audioRate: this.audioRate,
                    //使用时间轴插件
                    plugins: [
                        Timeline.create({
                        container: '#wave-timeline'
                        }),
                    ]
                });
                this.wavesurfer.on("play", () => {
                    // setTimeout(()=>{
                    //     let lrcUl=document.getElementsByClassName('van-picker-column__wrapper');
                    //     lrcUl.item(0).style.cssText="padding-top:100px;"
                    // },1000)
                });
                this.wavesurfer.load(require('@/assets/SIP-10193_50243456_20191202092311.wav'));
                this.recordWaveSurferFn();
                this.columns =lrc;
                setTimeout(() => {
                    this.audio=document.querySelector('#waveform audio');
                    this.audio.addEventListener("timeupdate",this.timeupdate,false);
                    this.audio.addEventListener("loadedmetadata",this.loadedmetadata,false);
                    this.addNode();
                }, 200);
            });
        },
        methods: {
            addNode(){
                let lrcLi=document.getElementsByClassName('van-picker-column__item');
                    this.columns.forEach((item,index)=>{
                        let divColor=lrcLi.item(index).querySelector('.van-ellipsis');
                        divColor.style.cssText="position: absolute;left: 104px;top: 6px;"
                        if(item.indexOf('n0')!==-1){
                                this.warns.forEach((ite)=>{
                                    if(item.indexOf(ite)!==-1){
                                        divColor.style.background='#f90 !important';
                                    }
                                });
                                this.keyword.forEach((ites)=>{
                                    if(item.indexOf(ites)!==-1){
                                        divColor.style.color='#ed4014 !important';
                                    }
                                });
                                lrcLi.item(index).style.cssText=`justify-content: flex-start;align-items: center;height:${divColor.offsetHeight}px;`
                                var divNode=document.createElement('div');
                                    divNode.style.cssText="display: flex;align-items: center;color:#fff;font-size: 12px;width: 100px;flex-wrap: wrap;flex-shrink: 0;justify-content: flex-start;"
                                let imgNode = document.createElement('img');
                                    imgNode.src=require('../../assets/client.png');
                                    imgNode.style.cssText="width: 25px;height: 32px;margin:0 2px;"
                                let imgNoded = document.createElement('img');
                                    imgNoded.src=require('../../assets/5334758802bc8c0321fb377dbd0920b0.gif');
                                    imgNoded.style.cssText="width: 25px;height: 25px;margin:0 2px;display:none"
                                let spanNode = document.createElement('span');
                                    spanNode.style.cssText="margin:2px 0;padding:0 7px;color: #808695;border:1px solid #808695;background: 0 0;"
                                    spanNode.innerText=`${item.substring(item.indexOf("[")+1,item.lastIndexOf("."))}`;
                                let inputNode = document.createElement('input');
                                    inputNode.type="checkbox";
                                    inputNode.value=item.substring(item.indexOf("：")+1);
                                    divNode.appendChild(inputNode);
                                    divNode.appendChild(imgNode);
                                    divNode.appendChild(imgNoded);
                                    divNode.appendChild(spanNode);
                                var buttonNode = document.createElement('button');
                                    buttonNode.type="text";
                                    let cssTexts={
                                        info:"padding:0 7px;color: #2db7f5;border:1px solid #2db7f5;background: 0 0;",
                                        success:"padding:0 7px;color: #47cb89;border:1px solid #47cb89;background: 0 0;",
                                        warning:"padding:0 7px;color: #ffad33;border:1px solid #ffad33;background: 0 0;",
                                        error:"padding:0 7px;color: #f16643;border:1px solid #f16643;background: 0 0;"};
                                    buttonNode.style.cssText="";
                                    this.voiceContent.client.forEach((it,ind)=>{
                                        if(it.time==item.substring(item.indexOf("[")+1,item.indexOf("]"))){
                                            buttonNode.innerText=it.content;
                                            buttonNode.style.cssText=`${cssTexts[it.type]}`;
                                            divNode.appendChild(buttonNode);
                                            buttonNode.onclick=()=>{
                                                this.changeTag(it.content,ind,index);
                                            };
                                        }
                                    })
                                    lrcLi.item(index).insertBefore(divNode,lrcLi.item(index).childNodes[0]);    
                                    divColor.innerText=item.substring(item.indexOf("：")+1);
                                    // 词逐字滚动；
                                    let divNode1=document.createElement('div');
                                    divNode1.style.cssText="font-size: 12px;position:absolute;left:104px;top:0px;color:red;top:6px;";
                                    divNode1.classList.add('cover1');
                                    this.cover1=divNode1;
                                    lrcLi.item(index).appendChild(divNode1);
                                    this.divNodeis++;
                        }else{
                            lrcLi.item(index).style.cssText=`justify-content: flex-end;align-items: center;height:${divColor.offsetHeight}px;`
                            let divNode=document.createElement('div');
                                divNode.style.cssText="display: flex;align-items: center;color:#fff;font-size: 12px;width: 100px;flex-wrap: wrap;flex-shrink: 0;justify-content: flex-start;"
                            let imgNode = document.createElement('img');
                                imgNode.src=require('../../assets/客户.png');
                                imgNode.style.cssText="width: 25px;height: 32px;margin:0 2px;"
                            let imgNoded = document.createElement('img');
                                imgNoded.src=require('../../assets/5334758802bc8c0321fb377dbd0920b0.gif');
                                imgNoded.style.cssText="width: 25px;height: 25px;margin:0 2px;display:none"
                            let spanNode = document.createElement('span');
                                spanNode.style.cssText="margin:2px 0;padding:0 7px;color: #808695;border:1px solid #808695;background: 0 0;"
                                spanNode.innerText=`${item.substring(item.indexOf("[")+1,item.lastIndexOf("."))}`;
                            let inputNode = document.createElement('input');
                                inputNode.type="checkbox";
                                inputNode.value=item.substring(item.indexOf("：")+1);
                                divNode.appendChild(inputNode);
                                divNode.appendChild(imgNode);
                                divNode.appendChild(imgNoded);
                                divNode.appendChild(spanNode);
                            let buttonNode = document.createElement('button');
                                buttonNode.type="text";
                                let cssTexts={
                                    info:"padding:0 7px;color: #2db7f5;border:1px solid #2db7f5;background: 0 0;",
                                    success:"padding:0 7px;color: #47cb89;border:1px solid #47cb89;background: 0 0;",
                                    warning:"padding:0 7px;color: #ffad33;border:1px solid #ffad33;background: 0 0;",
                                    error:"padding:0 7px;color: #f16643;border:1px solid #f16643;background: 0 0;"};
                                buttonNode.style.cssText="";
                                this.voiceContent.client.forEach((it,ind)=>{
                                    if(it.time==item.substring(item.indexOf("[")+1,item.indexOf("]"))){
                                        buttonNode.innerText=it.content;
                                        buttonNode.style.cssText=`${cssTexts[it.type]}`
                                        divNode.appendChild(buttonNode);
                                        buttonNode.onclick=()=>{
                                            this.changeTag(it.content,ind,index);
                                        };
                                    }
                                })
                                lrcLi.item(index).appendChild(divNode,lrcLi.item(index));
                                divColor.innerText=item.substring(item.indexOf("：")+1);

                                // 词逐字滚动；
                                divColor.style.cssText="position: absolute;right: 104px;top: 6px;"
                                let divNode1=document.createElement('div');
                                divNode1.style.cssText="font-size: 12px;position:absolute;right:104px;text-align: right;top:0px;color:red;top:6px;";
                                divNode1.classList.add('cover1');
                                this.cover1=divNode1;
                                lrcLi.item(index).appendChild(divNode1);
                        }
                    })
            },
            edit(){
                let lrcLi=document.getElementsByClassName('van-picker-column__item');
                let li=lrcLi[this.itemIndex].querySelectorAll('div')[0].querySelector('button');
                if(li==null){
                    li=lrcLi[this.itemIndex].querySelectorAll('div')[1].querySelector('button');
                }
                li.innerText=this.tagVal;
                this.voiceContent.client[this.tagIndex].content=this.tagVal;
                this.tagModal=false;
                // this.addNode();
            },
            dele(){
                this.voiceContent.client.splice(this.tagIndex,1);
                let lrcLi=document.getElementsByClassName('van-picker-column__item');
                let li=lrcLi[this.itemIndex].querySelectorAll('div')[0].querySelector('button');
                if(li==null){
                    li=lrcLi[this.itemIndex].querySelectorAll('div')[1].querySelector('button');
                }
                li.remove();
                this.tagModal=false;
            },
            changeS(val){
                switch(val){
                    case 1 :
                        this.$router.push({
                            path:'/'
                        })
                    break;
                    case 2 :
                        this.$router.push({
                            path:'/callDetailT'
                        })
                    break;
                    case 3 :
                        this.$router.push({
                            path:'/callDetailS'
                        })
                    break;
                }
                
            },
            change (status) {
                console.log(status);
            },
            play() {
                clearTimeout(playTimeoutTag)
                playTimeoutTag = setTimeout(() => {
                    this.wavesurfer.play();
                }, 200);
            },
            keyInfo(){
                this.moda=true;
            },
            toTime(time){
                this.wavesurfer.play([time,])
            },
            pause() {
                clearTimeout(playTimeoutTag)
                this.wavesurfer.pause()
            },
            stop(){
                this.wavesurfer.stop();
            },
            changeTag(tag,tagIndex,index){
                this.tag=tag;
                this.tagIndex=tagIndex;
                this.itemIndex=index;
                this.pause();
                this.tagModal=true;
            },
            progressChange(val) {
                this.pause()
                this.audio.currentTime = val;
                this.play();
            },
            loadedmetadata() {
                console.log(11);
                this.progressCurrent = this.audio.currentTime;
                this.progressLength = this.audio.duration;
                this.volume = this.audio.volume * 100
            },
            lrcpickerchange(el, value) {
                console.log(22);
                var time = value && value.match(/(\d+):(\d+)\.(\d+)/);
                if (time && time.length) {
                    this.audio.currentTime = time[1] * 60 + (+time[2]);
                    this.play()
                }
            },
            timeupdate() {
                this.progressCurrent = this.audio.currentTime;
                var findItem = this.columns.findIndex(v => {
                    var result = v.match(/(\d+):(\d+)\.(\d+)/);
                    if (result && result.length) {
                        var value = result[1] * 60 + (+result[2]);
                        return value > this.audio.currentTime
                    }
                    return false
                }) || -1;
                // this.timeupdatePos();
                this.$refs.lrcpicker.setValues([this.columns[Math.min(Math.max(0, findItem - 1), this.columns.length - 1)]]);
            },
            timeupdatePos(){
                lrc.forEach((item)=>{
                    let textItem={
                        startTime:null,
                        role:null,
                        text:null,
                        state:'verse'
                    }
                    textItem.startTime=this.createdTime(item.substring(item.indexOf("[")+1,item.indexOf("]")));
                    textItem.role=item.substring(item.indexOf("n"),item.indexOf("n")+2);
                    textItem.text=item.substring(item.indexOf("：")+1);
                    this.lrcText.push(textItem);
                });
                let i =this.findPosition(this.audio.currentTime) ; 
                if(this.last == i ){
                    return ;
                }
                this.last = i ;
                let d =this.getTimeDistance(i) ;
				let l = this.lrcText[i].text.length * 32 ;
				this.currentLen = 0 ; 
				this.dLen = l/d*3 ; 
                this.setLyric(this.lrcText[i].text,i);
                this.setLength(this.currentLen,i);
				if(timer!=null){
                    clearInterval(timer)
                }
                timer = setInterval(()=>{
                    this.currentLen += this.dLen ; 
                    this.setLength(this.currentLen,i) ; 
                },1);
            },
            createdTime(time){
                var temp=time.split(':');
                var tem=temp[1].split('.');
                temp.pop();
                temp=temp.concat(tem);
                var seconds = 60 * Number(temp[0]) + Number(temp[1]) + Number(temp[2])/1000;
                return seconds;
            },
            findPosition(time){
				for(let i = 0 ; i < this.lrcText.length ; ++i){
					if(time < this.lrcText[i].startTime || i == this.lrcText.length - 1 ) {
						return i-1 > 0 ? i-1 :0  ;
					}  
				}
            },
            getTimeDistance(i){
				if(i == this.lrcText.length - 1) return 5000 ;
				return parseInt(1000*(this.lrcText[i+1].startTime  - this.lrcText[i].startTime ));
            },
            setLyric(str,i){
                let cover1=document.querySelectorAll('.cover1');
                let cover=document.querySelectorAll('.van-ellipsis');
                // let cover2=document.querySelectorAll('.cover2');
                // let cover3=document.querySelectorAll('.cover3');
                var contentArr =str;
                let content="";
                let index=0;
                var ID = setInterval(function () {
                    content += contentArr[index];
                    if(index==0){
                        cover[i].style.opacity=0;
                    }
                    cover1[i].innerHTML = content + "_"; 
                    index++;
                    if(index === contentArr.length){
                    cover1[i].innerHTML = content; 
                        clearInterval(ID);
                        cover1[i].innerHTML=null;
                        cover[i].style.opacity=1;
                    }
                },150);
            },
            setLength(len,index){
                let cover=document.querySelectorAll('.van-ellipsis')
                let cover1=document.querySelectorAll('.cover1');
                // let cover2=document.querySelectorAll('.cover2');
                // let cover3=document.querySelectorAll('.cover3');
                if(len<cover[index].offsetWidth){
                    cover1[index].style.width = len + "px"; 
                    // cover2[index].style.width = len + "px"; 
                    // cover3[index].style.width = len + "px";
                }
			},
            addReviews(){
                this.reviewsModal=true;
            },
            selectReviews(){
                let lrcLi=document.getElementsByClassName('van-picker-column__item');
                lrcLi.forEach((item)=>{
                    if(item.querySelector('input').checked){
                        this.checkeds.push(item.querySelector('input').value);
                    }
                })
                this.title=`选中${this.checkeds.length}条进行点评`;
                this.wavesurfer.pause();
                this.moda=true;
            },
            recordWaveSurferFn(){
                this.recordWaveSurfer = WaveSurfer.create({
                    container: this.$refs.recordWaveSurfer,
                    height:20,
                    plugins: [
                        MicrophonePlugin.create(),
                    ]
                });
                this.recordWaveSurfer.microphone.on('deviceReady', function(stream) {
                    console.log('Device ready!', stream);
                });
                this.recordWaveSurfer.microphone.on('deviceError', function(code) {
                    console.warn('Device error: ' + code);
                });
            },
            record(){
                this.recordModal=true;
            },
            recordPlay(){
                let that=this;
                // navigator.mediaDevices.getUserMedia(constraints)
                // .then((stream)=>{
                //     console.log(stream);
                //     this.recordWaveSurfer.microphone.start();
                // })
                // .catch((err)=> {
                //     this.recordWaveSurfer.microphone.start();
                //     console.log(err);
                // });
                if (navigator.mediaDevices === undefined) {
                    navigator.mediaDevices = {};
                }
                if (navigator.mediaDevices.getUserMedia === undefined) {
                    navigator.mediaDevices.getUserMedia = function (constraints) {
                        var getUserMedia = navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
                        if (!getUserMedia) {
                            return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
                        }
                        //否则，使用Promise将调用包装到旧的navigator.getUserMedia
                        return new Promise(function (resolve, reject) {
                            getUserMedia.call(navigator, constraints, resolve, reject);
                        });
                    }
                }
                let constraints = { audio: true}
                navigator.mediaDevices.getUserMedia(constraints)
                    .then((stream)=> {
                        console.log(stream);
                        that.recordWaveSurfer.microphone.start();
                    })
                    .catch((err)=> {
                        console.log(err.name + ": " + err.message);
                    });
                
            },  
            recordStop(){
                this.recordModal=false;
                this.recordWaveSurfer.microphone.pause();
            },
            ok(){
                this.reviewsModal=false;
            },
            cancel() {
                this.reviewsModal=false;
                this.play();
                this.checkeds=[];
            }
        }
    }
</script>

<style scoped lang="scss">
    .wrap {
        padding: 10px;
        background: #f5f7f9;
        max-width: 1300px;
        min-height: 100vh;
        margin: 0 auto;
        .waveform-wrap{
            background-color: #fff;
            border: 1px solid #e3e7f1;
            border-top: none;
            padding: 0 10px;
            wave{
                height: 100px !important;
            }
            .lrc-column{
                justify-content: center;
                flex-direction: column;
                align-items: flex-end;
            }
        }
        .voice-content{
            background-color: #fff;
            border-bottom: none;
            padding-bottom: 10px;
            div{
                display: flex;
                .person-type{
                    flex: 0 0 70px;
                }
            }
            .client-wrap{
                ul{
                    li:nth-child(3){
                        display: none;
                    }
                }
            }
            ul{
                display: flex;
                justify-content: space-around;
                flex-grow: 1;
                flex-shrink: 0;
                li{
                    color: #fff;
                    padding: 0 10px;
                }
            }
        }
        .opera-warp{
            display: flex;
            justify-content: space-between;
            align-items: center;
            height: 45px;
            background-color: #fff;
            border-left: 1px solid #e3e7f1;
            border-right: 1px solid #e3e7f1;
            padding: 0 10px;
            .opera-left{
                display: flex;
                align-items: center;
                justify-content: space-between;
                .controls-other{
                    display: flex;
                    align-items: center;
                    margin-left: 10px;
                    .ivu-switch{
                        margin-right: 10px;
                    }
                    .ivu-input-group{
                        width:auto;
                    }
                }
                .volume-wrap{
                    width: 100px;
                    margin-right: 20px;
                }
                .controls-wrap {
                    i{
                        margin-right: 10px;
                        cursor:pointer;
                    }
                }
            }
            .select-wrap{
                width: 25%;
                display: flex;
                align-items: center;
                .label-span{
                    flex-grow: 1;
                    text-align: right;
                }
                .ivu-select{
                    width: 200px;
                }
            }
            .ivu-slider{
                width: 100%;
            }
            /deep/.ivu-breadcrumb{
                display: flex;
                align-items: center;
                flex-grow: 1;
                flex-shrink: 0;
                span{
                    white-space: nowrap;
                }
            }
        }
        .content-wrap{
            display: flex;
            .lrc-wrap {
                flex-grow: 1;
                border: 1px solid #e3e7f1;
                height: 600px;
                /deep/.van-picker{
                    width: 100%;
                    height: 100%;
                    background:url('../../assets/Picture2.png') no-repeat;
                    background-size:100% 100%; 
                    background-attachment:fixed;
                    .van-picker__columns{
                        height: 100% !important;
                        .van-picker-column{
                            overflow-y: scroll;
                            [type=checkbox]{
                                z-index: 9999;
                                cursor: pointer;
                            }
                            .van-picker-column__wrapper{
                                .van-picker-column__item--selected{
                                    position:relative;
                                    div:first-of-type{
                                        img:nth-child(2){
                                            display: none!important;
                                        }
                                        img:nth-child(3){
                                            display: inline-flex !important;
                                        }
                                    }
                                    .van-ellipsis{
                                        color: #2db7f5 !important;
                                        border-color: rgba(0,0,0,0.5) !important;
                                    }
                                }
                                .van-picker-column__item--selected:nth-of-type(odd){
                                    div:nth-of-type(2){
                                        img:nth-child(2){
                                            display: none!important;
                                        }
                                        img:nth-child(3){
                                            display: inline-flex !important;
                                        }
                                    }
                                    .van-ellipsis{
                                        color: #2db7f5 !important;
                                        border-color: rgba(0,0,0,0.5);
                                    }
                                }
                            }
                            /deep/.van-ellipsis{
                                white-space:pre-wrap;
                                font-size: 12px;
                                overflow: inherit;
                            }
                            .van-picker-column__item:nth-child(even){
                                .van-ellipsis{
                                    position: absolute;
                                    margin-right: 104px;
                                    padding: 0;
                                    background-color: #DEE0E3;
                                    border-color: #DEE0E3;
                                    display:block;
                                    border:1px solid rgba(0,0,0,0.5);
                                    border-radius: 4px;
                                    padding: 2px;
                                }
                                .van-ellipsis::before{
                                    content: ' ';
                                    display: block;
                                    border-right:7px solid #DEE0E3;
                                    border-left:7px solid  transparent;
                                    border-top:7px solid  transparent;
                                    border-bottom: 7px solid transparent;
                                    width: 0px;
                                    height: 0px;
                                    position: absolute;
                                    top:4px;
                                    left: -14px;
                                    z-index: 3;
                                }
                                .van-ellipsis::after{
                                    content: ' ';
                                    display: block;
                                    border-right:8px solid rgba(0,0,0,0.5);
                                    border-left:8px solid  transparent;
                                    border-top:8px solid  transparent;
                                    border-bottom: 8px solid transparent;
                                    width: 0px;
                                    height: 0px;
                                    position: absolute;
                                    top:3px;
                                    left: -16.5px;
                                    z-index: 2;
                                }
                            }
                            
                            .van-picker-column__item:nth-child(odd){
                                .van-ellipsis{
                                    position: absolute;
                                    margin-left: 104px;
                                    padding: 0;
                                    // color: #86181d;
                                    background-color: #CCE4FC;
                                    border-color: #CCE4FC;
                                    display:block;
                                    border:1px solid rgba(0,0,0,0.5);
                                    border-radius: 4px;
                                    padding: 2px;
                                    margin-right: 10px;
                                }
                                .van-ellipsis::before{
                                    content: ' ';
                                    display: block;
                                    border-right:7px solid transparent;
                                    border-left:7px solid  #CCE4FC;
                                    border-top:7px solid  transparent;
                                    border-bottom: 7px solid transparent;
                                    width: 0px;
                                    height: 0px;
                                    position: absolute;
                                    top:4px;
                                    right:-14px;
                                    z-index: 3;
                                }
                                .van-ellipsis::after{
                                    content: ' ';
                                    display: block;
                                    border-right:8px solid transparent;
                                    border-left:8px solid  rgba(0,0,0,0.5);
                                    border-top:8px solid  transparent;
                                    border-bottom: 8px solid transparent;
                                    width: 0px;
                                    height: 0px;
                                    position: absolute;
                                    top:3px;
                                    right:-16.5px !important;
                                    z-index: 2;
                                }
                            }
                        }
                    }
                    .van-picker__mask{
                        display: none;
                    }
                }
            }
            .content-right{
                width: 33%;
                flex-shrink: 0;
                padding: 0 10px;
                ul{
                    .li-f{
                        margin-bottom: 20px;
                        h3{
                            margin-bottom: 10px;
                        }
                        .call{
                            display: flex;
                            img{
                                width: 25px;
                                height: 36px;
                            }
                            .call-l{
                                margin-right:10px;
                                flex-shrink: 0;
                            }
                            .call-r{
                                flex-grow: 1;
                                text-align: right;
                                display: flex;
                                flex-direction: column;
                                align-items: flex-end;
                                ul{
                                    display: flex;
                                    flex-wrap: wrap;
                                    justify-content: flex-end;
                                    li{
                                        padding: 2px;
                                    }
                                }
                            }
                        }
                        p{
                            padding-bottom: 10px;
                            
                        }
                        .num{
                            padding-left: 10px;
                        }
                    }
                    .li-f-content{
                        ul{
                            display: flex;
                            flex-wrap: wrap;
                            li{
                                padding: 5px;
                            }
                        }
                    }
                    .li-s{
                        display: flex;
                        padding: 5px 0;
                        .fer-label{
                            line-height: 30px;
                            text-align: right;
                        }
                        ul{
                            display: flex;
                            flex-wrap: wrap;
                            align-items: center;
                            .li-t{
                                display: flex;
                                padding: 5px;
                            }
                        }
                    }
                    .li-s-key{
                        flex-direction: column;
                        .info-wrap{
                            .ivu-btn-text{
                                color: #57a3f3;
                            }
                        }
                        img{
                            padding: 0 5px;
                        }
                    }
                }
                .record-btn{
                    cursor: pointer;
                    margin-left:10px; 
                }
            }
        }
    }
    /deep/.ivu-modal-wrap{
        img{
            height: 100px;
            width: 100%;
        }
    }
    .ivu-modal-body{
        p{
            border-bottom: 1px solid #e3e7f1;
            margin-bottom: 10px;
        }
    }
    .flex {
        display: flex;
        align-items: center;
    }
    .progress-time {
        width: 8em;
        text-align: center;
    }
    /deep/.van-picker-column__item{
        margin: 10px 0 10px 0;
        position: relative;
    }
</style>